//+------------------------------------------------------------------+
//|                                         SOUTHVEST INVESTMENT.mq5 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+

#include<Trade/Trade.mqh>

// Create an instance of Ctrade
CTrade trade;

//input int MyTakeProfitValue = 300;

//input int MyStopLossValue = 100;


void OnTick()
 
{     
   static double LastStopMovingAverageValue;

   
   string signal ="";

// WE CALCULATE THE ASK PRICE
   double Ask=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);

   double Bid=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
//-----------------------------------------------------------------------------
// create an array for several prices
   double myMovingAverageArray1[],myMovingAverageArray2[];

// DEFINE THE PRROPERTIERS OF THE MOVING AVERAGE
   int movingAverageDefiniton1 = iMA(_Symbol,_Period,1,0,MODE_SMA,PRICE_LOW);

// DEFINE THE PRROPERTIERS OF THE MOVING AVERAGE
   int movingAverageDefiniton2 = iMA(_Symbol,_Period,100,0,MODE_SMA,PRICE_LOW);

// sort the array from the current candle downwards
// ArraySetAsSeries(mySARArray,true);

  // double CurrentStopLoss=PositionGetDouble(POSITION_SL);

  // double CurrentTakeProfit=PositionGetDouble(POSITION_TP);

// SORT THE PRICE ARRAY FROM THE CURRENT CANDLE DOWNWARDS
   ArraySetAsSeries(myMovingAverageArray1,true);

// SORT THE PRICE ARRAY FROM THE CURRENT CANDLE DOWNWARDS
   ArraySetAsSeries(myMovingAverageArray2,true);

//DEFINE MA1 one line current candle 3 candles store result
   CopyBuffer(movingAverageDefiniton1,0,0,3,myMovingAverageArray1);

//DEFINE MA1 one line current candle 3 candles store result
   CopyBuffer(movingAverageDefiniton2,0,0,3,myMovingAverageArray2);

// remove its for trailing stop calculate the value for the last candle
//double SARValue=NormalizeDouble(mySARArray[0],5);


   if(  /// check if the 3 candle is above the 300 candle ea
      (myMovingAverageArray1[0]>myMovingAverageArray2[0])
      &&(myMovingAverageArray1[1]<myMovingAverageArray2[1])
     )
    
     {

      signal="buy";
     }
/// BUY 10 microlots
// PositionsTotal()<5
   if(signal =="buy" && PositionsTotal()<1)
      trade.Buy(0.01,NULL,Ask,0,0,NULL);
    
     
//CREATE A CHART OUT PUT
  // Comment("The current signal is ",signal);
    
    LastStopMovingAverageValue=0;  
    
    double myMovingAverageArray[];
    
    ArraySetAsSeries(myMovingAverageArray,true);
    
    int movingAverageDefiniton= iMA(_Symbol,_Period,100,0,MODE_SMA,PRICE_MEDIAN);
    
    
    CopyBuffer(movingAverageDefiniton,0,0,3,myMovingAverageArray);
    
    
    double StopMovingAverageValue = myMovingAverageArray[1];
    
   
    if (StopMovingAverageValue > Bid)
    
   
    if (StopMovingAverageValue> LastStopMovingAverageValue)
   
      { 
        CloseAllBuyPositions (Bid, StopMovingAverageValue);
      
        LastStopMovingAverageValue= StopMovingAverageValue;

      }
    
  }
 
void   CloseAllBuyPositions (double Bid, double StopMovingAverageValue)
 
  {
    //go throught all the positions 
     for(int i=PositionsTotal()-1; i>=0; i--)
      {
         string symbol =PositionGetSymbol(i); // GET THE SYMBOL OF THE POSITION 
         
            int ticket=PositionGetTicket(i);
            
            int PositionDirection=PositionGetInteger(POSITION_TYPE);
            
            if (PositionDirection==POSITION_TYPE_BUY)
            
            trade.PositionClose(ticket);
    
    
         } 

   }   